function Sender() {
  this.deferredMap = {}
  this.init()
}

Sender.prototype.init = function() {
  var me = this
  window.addEventListener('message', function(event) {
    if (event.data && event.data.eventId) {
      var deferred = me.deferredMap[event.data.eventId]
      if (deferred) {
        deferred.resolve(event.data.result)
      }
    }
  })
}

Sender.prototype.executeScript = function(script, data) {
  var eventId = Math.random()
  document.querySelector('[name=frameEditor]').contentWindow.postMessage({
    script: script,
    eventId: eventId,
    data: data
  }, '*')
  this.deferredMap['reply#' + eventId] = new Deferred()
  return this.deferredMap['reply#' + eventId].promise
}

function Deferred() {
  var ret = {}
  ret.promise = new Promise(function(resolve, reject) {
    ret.resolve = resolve
    ret.reject = reject
  })
  return ret
}

module.exports = Sender
